version: '3.8'

services:

{% for node in minio_nodes %}
  {{ node }}:
    image: {{ minio_docker_image }}:{{ minio_docker_tag }}
    hostname: {{ node }}
    volumes:
      - {{ minio_dir }}/data:/data
    networks:
      - host
    deploy:
      restart_policy:
        delay: 10s
        max_attempts: 10
        window: 60s
      placement: 
        constraints: 
          - node.hostname=={{ node }}
    command: server --console-address ":9001" {% for n in minio_nodes %}http://{{ n }}/data {% endfor %}

    healthcheck:
      test: ["CMD", "curl", "-f", "http://localhost:9000/minio/health/live"]
      interval: 30s
      timeout: 20s
      retries: 3
    secrets:
      - secret_key
      - access_key
    extra_hosts:
    {% for n in minio_nodes %}
  - "{{ n }}:{{ hostvars[n]['ansible_facts']['default_ipv4']['address'] }}"
    {% endfor %}

{% endfor %}

networks:
  host:
    external: true

secrets:
  secret_key:
    external: true
  access_key:
    external: true
